// Demonstrates various facilities of printf and String.format() Look
// at the printed messages to see how the format strings affect output
public class PrintfDemo{
  public static void  main(String args[]){
    int i = 152;

    System.out.printf("Play with width\n");
    System.out.printf("|%d|\n",i);
    System.out.printf("|%5d|\n",i);
    System.out.printf("|%10d|\n",i);
    System.out.printf("|%20d|\n",i);
    System.out.printf("\n");

    System.out.printf("Play with justification\n");
    System.out.printf("|%10d| Left by default\n",i);
    System.out.printf("|%-10d| Right with -\n",i);
    System.out.printf("\n");

    double d = 1.23456789;
    System.out.printf("Play with precision\n");
    System.out.printf("%f\n",d);
    System.out.printf("%.0f\n",d);
    System.out.printf("%.1f\n",d);
    System.out.printf("%.3f\n",d);
    System.out.printf("%.10f\n",d);
    System.out.printf("\n");

    System.out.printf("Play with precision and width\n");
    System.out.printf("%10f\n",d);
    System.out.printf("%10.0f\n",d);
    System.out.printf("%10.1f\n",d);
    System.out.printf("%10.3f\n",d);
    System.out.printf("%10.10f\n",d);
    System.out.printf("\n");

    System.out.printf("Format scientifically\n");
    System.out.printf("%e\n",d);
    System.out.printf("%.4e\n",d);
    System.out.printf("%16.4e\n",d);
    System.out.printf("%16.6e\n",d);
    System.out.printf("%16.6e\n",-d);
    System.out.printf("%-16.6e\n",d);
    System.out.printf("%-16.6e\n",-d);
    System.out.printf("\n");

    String s = "I'm a string";
    System.out.printf("Width & justifcation on strings too\n");
    System.out.printf("|%s|\n",s);
    System.out.printf("|%20s|\n",s);
    System.out.printf("|%-20s|\n",s);
    System.out.printf("|%25s|\n",s);
    System.out.printf("|%-25s|\n",s);

    // Compare
    System.out.println("Using println");
    System.out.println("Integers Doubles");
    for(i=0; i<10; i++){
      d = i * 1.234567;
      System.out.println("" + i + " " + d);
    }

    System.out.println("Using printf");
    System.out.printf("%16s %16s %16s %16s\n","Integers","ZeroPad","Doubles","Scientific");
    String form = "%16d %016d %16.5f %16.4e\n";
    for(i=0; i<10; i++){
      d = i * 1.234567;
      System.out.printf(form,i,i,d,d);
    }

    // String.format(form,arg1,arg2,...)
    //
    // This function has the same flavor as printf() but creates a
    // string rather than printing it to the screen. Useful for
    // formatted toString() methods


    System.out.println("Using String.format()");
    String formatted = String.format("An int %d, a double %6.2f, a string %s",
                                     123, 45.6789, "stuff");
    System.out.println(formatted);
  }
}
