// WARNING: This file is for demonstration purposes and DOES NOT
// FOLLOW NORMAL JAVA CONVENTIONS.  It is meant to contrast the
// OOOmelet which provides the same basic functionality in a more
// conventional OO style
//
// Perform various operations and checks on SOmelet objects using
// static methods. The definition of an SOmelet is in SOmelet.java

public class SOmeletMethods {
  // Create a custom-sized omelet. 
  public static SOmelet constructSOmelet(int eggs,
                                         int ozCheese){
    SOmelet thisOmelet = new SOmelet();
    thisOmelet.eggs = eggs;
    thisOmelet.ozCheese = ozCheese;
    thisOmelet.extraIngredients = new String("");
    thisOmelet.totalCookMinutes = 0.0;
    return thisOmelet;
  }

  // Construct a standard 3-egg omelet. This method is distinguished
  // from the previous as it takes no arguments.
  public static SOmelet constructSOmelet(){
    return constructSOmelet(3, 4);
  }

  // Add an extra ingredient to an omelet
  public static void addIngredient(SOmelet thisOmelet,
                                   String ingredient){
    thisOmelet.extraIngredients += ingredient + " ";
  }    


  // Cook an omelet for the given amount of time
  public static void cookFor(SOmelet thisOmelet,
                             double cookMinutes){
    thisOmelet.totalCookMinutes += cookMinutes;
  }

  // Determine if the omelet has been burned while cooking
  public static boolean isBurned(SOmelet thisOmelet){
    return thisOmelet.totalCookMinutes > 2.0 * thisOmelet.eggs;
  }

  // Determine if consumption of the given omelet is risky
  public static boolean foodPoisoningIminent(SOmelet thisOmelet){
    return thisOmelet.totalCookMinutes < 1.0 * thisOmelet.eggs;
  }

  // Constants defining calories of standard ingredients in omelets
  public static final int EGG_CALORIES = 94;
  public static final int CHEESE_OZ_CALORIES = 114;

  // Calculate the calorie count of the basic omelet ingredients. Does
  // not account for extra ingredients
  public static int getBaseCalories(SOmelet thisOmelet){
    return
      thisOmelet.eggs     * EGG_CALORIES +
      thisOmelet.ozCheese * CHEESE_OZ_CALORIES;
  }

}
