// Demonstrate the use of POmelet in a main.
//
// Note: cannot access fields eggs/ozCheese anymore. These are now
// private fields (unlike in OOOmelet) and require use of accessor
// methods like getEggs() instead.
public class UsePOmelet {
  public static void main(String args[]){
    // Construct a standard omelet and show some of its contents
    POmelet standard = new POmelet();
    System.out.println(standard.getEggs());             // Use accessor
    System.out.println(standard.getExtraIngredients()); // Use accessor

    // Construct a proper American omelet and show some of its contents
    POmelet coronary = new POmelet(5,12); 
    coronary.addIngredient("bacon");
    coronary.addIngredient("ham");
    System.out.println(coronary.getEggs());             // Use accessor
    System.out.println(coronary.getExtraIngredients()); // Use accessor

    // How much else can I eat today?
    int calories;
    calories= standard.getBaseCalories();
    System.out.println("Standard calories: " + calories);
    calories= coronary.getBaseCalories();
    System.out.println("Coronary calories: " + calories);

    // Start cooking
    standard.cookFor(4.0);
    coronary.cookFor(4.0);

    boolean safe;
    safe = !standard.foodPoisoningIminent();
    System.out.println("Standard safe for consumption? "+safe);
    safe = !coronary.foodPoisoningIminent();
    System.out.println("Coronary safe for consumption? "+safe);

    POmelet o = new POmelet(3,4);

    // Demonstrate toString() implementation
    System.out.println(standard.toString());
    System.out.println(coronary); // toString() automatically called
    System.out.println(o); 

    // Demonstrate equals(o) method
    System.out.println( standard.equals(o) ); // true
    System.out.println( coronary.equals(o) ); // false
  }
}
